#ifndef _LSDTAPI_H_
#define _LSDTAPI_H_

int SDT_OpenPort(int iPort);
int SDT_ClosePort(int iPort);
int SDT_GetSAMStatus(int iPort,int bIfOpen);
int SDT_ResetSAM(int iPort,int bIfOpen);
int SDT_GetSAMIDToStr(int iPort,char *pcSAMID,int iIfOpen);
int SDT_GetSAMID(int iPort,unsigned char *pucSAMID,int iIfOpen);
int SDT_StartFindIDCard(int iPort,unsigned char *pucIIN,int bIfOpen);
int SDT_GetCOMBaud(int iPort,unsigned int  *puiBaud);
int SDT_SetCOMBaud(int iPort,unsigned int  uiCurrBaud,unsigned int  uiSetBaud);
int SDT_SetMaxRFByte(int iPort,unsigned char ucByte,int bIfOpen);
int SDT_SelectIDCard(int iPort,unsigned char *pucSN,int bIfOpen);
int SDT_ReadBaseMsg(int iPort,unsigned char * pucCHMsg,unsigned int *	puiCHMsgLen,unsigned char * pucPHMsg,unsigned int  *puiPHMsgLen,int bIfOpen);
int SDT_ReadBaseMsgToFile(int iPort, char *pcCHMsgFileName, unsigned int *puiCHMsgFileLen, char *pcPHMsgFileName, unsigned int *puiPHMsgFileLen, int iIfOpen);
int SDT_ReadBaseFPMsg(int iPort,unsigned char * pucCHMsg,unsigned int *	puiCHMsgLen,unsigned char * pucPHMsg,unsigned int *	puiPHMsgLen,unsigned char * pucFPMsg,unsigned int *	puiFPMsgLen,int bIfOpen);
int SDT_ReadBaseFPMsgToFile(int iPort, char *pcCHMsgFileName, unsigned int *puiCHMsgFileLen, char *pcPHMsgFileName, unsigned int *puiPHMsgFileLen, char *pcFPMsgFileName, unsigned int *puiFPMsgFileLen, int iIfOpen);
int SDT_ReadNewAppMsg(int iPort, unsigned char *pucAppMsg, unsigned int *puiAppMsgLen, int iIfOpen);

int	SDT_SetLowPower(int iPortID, int iIfOpen);
int	SDT_GetSAMCert(int iPortID, unsigned char * pucCert, unsigned int * puiCertLen, int iIfOpen);

int	SDT_ReadChkcode(int iPort,unsigned char * pucR1, char * pcSAMID, unsigned char * pucDataIn, unsigned char * pucT, unsigned char * pucChkcode, unsigned char * pucSign, int iIfOpen);
int	SDT_ReadChkcodePF(int iPort,unsigned char * pucR1, 
							  char * pcSAMID, unsigned char * pucDataIn, unsigned char * pucT, \
							  unsigned char * pucChkcode, unsigned char * pucHpf, unsigned char * pucSign, \
							  unsigned char * pucPH, unsigned int * puiPHLen, unsigned char * pucFP, unsigned int * puiFPLen, int iIfOpen);
int SDT_CheckIdencode(int iPort, unsigned char * pucR1, unsigned char ucNum, unsigned char * pucIdencode, unsigned int uiIdencodeLen, char * pcSAMID, unsigned char * pucDataIn,unsigned char * pucIndex,unsigned char * pucT, unsigned char * pucChkcode,unsigned char * pucSign,int iIfOpen);
int SDT_CheckIdencodePF(int iPort, unsigned char * pucR1, unsigned char ucNum, unsigned char * pucIdencode, unsigned int uiIdencodeLen, \
								 char * pcSAMID, unsigned char * pucDataIn,unsigned char * pucIndex,unsigned char * pucT, \
								 unsigned char * pucChkcode,unsigned char * pucHpf,unsigned char * pucSign,
								 unsigned char * pucPH, unsigned int * puiPHLen, unsigned char * pucFP, unsigned int * puiFPLen, int iIfOpen);
int SDT_CheckGender(int iPort, unsigned char * pucR1, unsigned char ucAddr, unsigned char * pucGender, char * pcSAMID, unsigned char * pucDataIn,unsigned char * pucRst, unsigned char * pucSign, int iIfOpen);
int SDT_CheckBirthdate(int iPort, unsigned char * pucR1, unsigned char ucAddr, unsigned char * pucBirthdate, char * pcSAMID, unsigned char * pucDataIn, unsigned char *pucRst, unsigned char * pucSign, int iIfOpen);

int SDT_UserLogin(int iPortID, unsigned char * pucPIN, int iIfOpen);
int SDT_UserPKImport(int iPortID, unsigned char * pucPKs, unsigned char * pucPKe, int iIfOpen);
int SDT_UserPKChgApply(int iPortID, unsigned char * pucR1, unsigned char * pucSAMID, int iIfOpen);
int SDT_UserPKChgCheck(int iPortID, unsigned char * pucID, unsigned int uiIDLen, unsigned char * pucR2, unsigned char * pucR1, unsigned char * pucPKs, unsigned char * pucPKe, unsigned char * pucSign, int iIfOpen);
int SDT_ExportAppCert(int iPortID, unsigned char * pucAppCert, unsigned int * puiAppCertLen, int iIfOpen);
int SDT_GetRandom(int iPortID, unsigned int uiRandomLen, unsigned char * pucRandom, int iIfOpen);
int SDT_SM2SignDigestInit(int iPortID, int iIfOpen);
int SDT_SM2VerifyDigestInit(int iPortID, unsigned char * pucZaID, unsigned int uiZaIDLen, int iIfOpen);
int SDT_SM2DigestUpdate(int iPortID, unsigned char * pucData, unsigned int uiDataLen, int iIfOpen);
int SDT_SM2DigestFinal(int iPortID, unsigned char * pucHash, int iIfOpen);
int SDT_SM2Sign(int iPortID, unsigned char * pucHash, unsigned char * pucSign, int iIfOpen);
int SDT_SM2Decrypt(int iPortID, unsigned char * pucData, unsigned int uiDataLen, unsigned char * pucDecData, unsigned int * puiDecDataLen, int iIfOpen);
int SDT_SM2Verify(int iPortID, unsigned char * pucHash, unsigned char * pucSign, unsigned char * pucRslt, int iIfOpen);
int SDT_SM2Encrypt(int iPortID, unsigned char * pucData, unsigned int uiDataLen, unsigned char * pucEncData, unsigned int * puiEncDataLen, int iIfOpen);
int SDT_SM3Digest(int iPortID, unsigned char *pucData, unsigned int uiDataLen, unsigned char * pucHash, int iIfOpen);
int SDT_SM3DigestInit(int iPortID, int iIfOpen);
int SDT_SM3DigestUpdate(int iPortID, unsigned char * pucData, unsigned int uiDataLen, int iIfOpen);
int SDT_SM3DigestFinal(int iPortID, unsigned char * pucHash, int iIfOpen);
int SDT_GenAgreeData(int iPortID, unsigned char * pucSID, unsigned int * puiSIDLen, unsigned char * pucSPKe, unsigned char * pucSPKr, int iIfOpen);
int SDT_GenSessionKey(int iPortID, unsigned char * pucRID, unsigned int uiRIDLen, unsigned char * pucRPKe, unsigned char * pucRPKr, int iIfOpen);
int SDT_GenAgreeDataKey(int iPortID, unsigned char * pucSID, unsigned int  uiSIDLen, unsigned char * pucSPKe, unsigned char * pucSPKr, unsigned char * pucRID, unsigned int * puiRIDLen, unsigned char * pucRPKe, unsigned char * pucRPKr, int iIfOpen);
int SDT_SM4WithSessionKey(int iPortID, unsigned char * pucAlgID, unsigned char * pucED, unsigned char * pucIV, unsigned char * pucData, unsigned int uiDataLen, unsigned char * pucEDData, unsigned int * puiEDDataLen, int iIfOpen);
int SDT_SM4WithLocalKey(int iPortID, unsigned char * pucAlgID, unsigned char * pucED, unsigned char * pucIV, unsigned char * pucData, unsigned int uiDataLen, unsigned char * pucEDData, unsigned int * puiEDDataLen, int iIfOpen);
int SDT_ReadUserSignPK(int iPortID, unsigned char * pucUserSignPK, unsigned int * puiUserSignPKLen, int iIfOpen);

#endif

